unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, ExtCtrls, ShellAPI,
  {Engine's units}
  Sys, Objects, Images, BmpModule;

type
  TForm1 = class(TForm)
    OpenD: TOpenDialog;
    SaveD: TSaveDialog;
    Button1: TButton;
    XPMan: TXPManifest;
    Button2: TButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    Formats: TRadioGroup;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormatsClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    Image: TImageData;

    procedure ViewCurrent;

  end;

var
  Form1: TForm1;

const
  TempName = '!@umajo@!.bmp';

implementation

{$R *.dfm}

procedure TForm1.ViewCurrent;
var
  Bmp: TBmpModule;
begin
  Bmp := TBmpModule.Create;
  try
    Bmp.EncodeFile(Image, ExeDir + TempName);
  finally
    Bmp.Free;
  end;
  ShellExecute(Handle, 'open', PChar(ExeDir + TempName), nil, nil, 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Code: TIDCode;
  I: Long;
  Module: IImageModule;
begin
  if not OpenD.Execute then
    Exit;

  case OpenD.FilterIndex of
    1: Code := 'IMG-PNG';
    2: Code := 'IMG-JPG';
    3: Code := 'IMG-TGA';
    4: Code := 'IMG-BMP';
    5: Code := 'IMG-DIMG';
    6: Code := 'IMG-DCIF';
    7: Code := 'IMG-DTEX';
  end;

  for I := 0 to ModuleRegister.ModuleInfos.Count - 1 do
    if Code = ModuleRegister.ModuleInfo[I].ModuleInfo.IDCode then
    begin
      Module := ModuleRegister.CreateModule(ModuleRegister.ModuleInfos[I]) as
        IImageModule;
      Break;
    end;

  if Module = nil then
    Exit;

  Module.DecodeFile(OpenD.FileName, Image);
  Formats.ItemIndex :=
    Formats.Items.IndexOf(ImageFormatToStr(Image.ImageFormat));

  Module := nil;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ViewCurrent;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DeleteFile(ExeDir + TempName);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  FilterBilinear(Image);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  FilterTrilinear(Image);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  FlipYImage(Image);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  SwapChannels(Image);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  Images.ConvertToGreyScale8(Image);
end;

procedure TForm1.FormatsClick(Sender: TObject);
var
  Img: TImage;
begin
  Img := TImage.CreateDirect(Image);
  case Formats.ItemIndex of
    0: Img.ImageFormat := ifR8G8B8;
    1: Img.ImageFormat := ifA8R8G8B8;
    2: Img.ImageFormat := ifX8R8G8B8;
    3: Img.ImageFormat := ifIntensity32;
    4: Img.ImageFormat := ifX1R5G5B5;
    5: Img.ImageFormat := ifA4R4G4B4;
    6: Img.ImageFormat := ifIntensity16;
    7: Img.ImageFormat := ifR5G6B5;
    8: Img.ImageFormat := ifIndex8;
    9: Img.ImageFormat := ifIntensity8;
    10: Img.ImageFormat := ifR3G3B2;
    11: Img.ImageFormat := ifA1R2G3B2;
  end;
  Image := Img.ImageData;
  Img.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Long;
  Module: IImageModule;
  Code: TIDCode;
begin
  if not SaveD.Execute then
    Exit;

  case OpenD.FilterIndex of
    1: Code := 'IMG-PNG';
    2: Code := 'IMG-JPG';
    3: Code := 'IMG-TGA';
    4: Code := 'IMG-BMP';
    5: Code := 'IMG-DIMG';
    6: Code := 'IMG-DCIF';
    7: Code := 'IMG-DTEX';
  end;

  for I := 0 to ModuleRegister.ModuleInfos.Count - 1 do
    if Code = ModuleRegister.ModuleInfo[I].ModuleInfo.IDCode then
    begin
      Module := ModuleRegister.CreateModule(ModuleRegister.ModuleInfos[I]) as
        IImageModule;
      Break;
    end;

  if Module = nil then
    Exit;

  Module.EncodeFile(Image, SaveD.FileName);
  Module := nil;
end;

end.

