{This is example of low-level module.
It is designed as compression module (although
it only negates memory).
Try load this module by Module Informator in \Demos
directory.}

library ModExLowFPC;


uses
  {Add unit with types required to build low-level module}
  ExtTypesFPC,
  Windows;


type

  Long = LongInt;


{*************************************************************************}
{                        Exported functions                               }
{*************************************************************************}


procedure ModuleCount(var Count: Long); cdecl;
begin
 {Return valid module count. We have only one module in this library.}
  Count := 1;
end;

procedure ModuleInfo(Index: Long; var Info: TModuleInfo); cdecl;
begin
 {Return valid info for low-level module.}
  FillChar(Info, SizeOf(Info), 0);
  Info.Name := 'Not Ext FPC Module';
  Info.Description := 'Negates given memory.';
  Info.LibName := 'ModExLowFPC.dll';
  Info.Creator := 'Joureck Jauder, Vempyre PostForks';
  Info.Language := 'Free Pascal';
  Info.IDCode := 'CMP-NOT';
  Info.Style := msLowLevel;
  Info.Platform := pfIndependent;
  Info.Version.Version := $00300100;
end;


function CompressBuffer(InData: Pointer;
  InSize: Long; var OutData: Pointer; var OutSize: Long): boolean; cdecl; forward;

function DecompressBuffer(InData: Pointer;
  InSize: Long; var OutData: Pointer; var OutSize: Long): boolean; cdecl; forward;

const
 {Extended info structure for extrnal compress modules
 with functions below set as module's methods.}
  Ext: TExtCompressInfo =
  (CanCompress: true; CanDecompress: true; CompressBuffer: CompressBuffer;
    DecompressBuffer: DecompressBuffer);

procedure ModuleExtInfo(Index: Long; var ExtInfo: Pointer); cdecl;
begin
 {Return module's extended info.}
  ExtInfo := @Ext;
end;


{*************************************************************************}
{                       Module's functions                                }
{*************************************************************************}


function CompressBuffer(InData: Pointer;
  InSize: Long; var OutData: Pointer; var OutSize: Long): boolean;cdecl;
type
  TByteArray = array[0..0] of Byte;
  PByteArray = ^TByteArray;
var
  I: Long;
begin
  Result := false;
  if (InData = nil) or (InSize = 0) then
    Exit;

  OutSize := InSize;
  { This is now big problem. Memory managers of supported languages
  behave different so meanwhile
  (until this problem is resolved ? Do you know how ?) we must use something what is   the same already.}
  OutData := Pointer(LocalAlloc(LMEM_FIXED,OutSize));

  {Simply negate every input byte.}
  for I := 0 to InSize - 1 do
    PByteArray(OutData)[I] := not PByteArray(InData)[I];

  Result := true;
end;

function DecompressBuffer(InData: Pointer;
  InSize: Long; var OutData: Pointer; var OutSize: Long): boolean;cdecl;
begin
  {We can call CompressBuffer because it does the same thing.}
  Result := CompressBuffer(InData, InSize, OutData, OutSize);
end;




exports
 {Export functions required by ModuleRegister.
 Names must be exact same.}
  ModuleCount,
  ModuleInfo,
  ModuleExtInfo;


begin
end.


